itpp::Fading_Generator Class Referenceabstract
Communications Module » Channel Modeling

Fading generator class. More...

`#include <itpp/comm/channel.h>`

Inheritance diagram for itpp::Fading_Generator:

## Public Member Functions

| Fading_Generator ()
| Default constructor.
virtual | ~Fading_Generator ()
| Destructor.
void | set_LOS_power (double relative_power)
| Set relative LOS power.
virtual void | set_LOS_doppler (double relative_doppler)
| Set relative Doppler of the LOS component (for correlated fading generators)
virtual void | set_time_offset (int offset)
| Set time offset in samples (for correlated fading generators)
virtual void | set_filter_length (int filter_length)
| Set FIR filter length (for FIR fading generator)
virtual void | set_norm_doppler (double norm_doppler)
| Set normalized Doppler (for correlated fading generators)
virtual void | set_doppler_spectrum (DOPPLER_SPECTRUM spectrum)
| Set Doppler spectrum (for Rice fading generator)
virtual void | set_no_frequencies (int no_freq)
| Set number of sine frequencies (for Rice fading generator)
virtual void | set_rice_method (RICE_METHOD method)
| Set calculation method of Doppler frequencies and amplitudes (for Rice fading generator)
double | get_LOS_power () const
| Get relative power of LOS component (Rice factor)
virtual double | get_LOS_doppler () const
| Get relative Doppler of the LOS component (for correlated fading generators)
virtual double | get_time_offset () const
| Get time offset in samples (for correlated fading generators)
virtual int | get_filter_length () const
| Set FIR filter length (for FIR fading generator)
virtual double | get_norm_doppler () const
| Return normalized Doppler (for correlated fading generators)
virtual DOPPLER_SPECTRUM | get_doppler_spectrum () const
| Return Doppler spectrum (for Rice fading generator)
virtual int | get_no_frequencies () const
| Get number of sine frequencies (for Rice fading generator)
virtual RICE_METHOD | get_rice_method () const
| Get calculation method of Doppler frequencies and amplitudes (for Rice fading generator)
virtual void | shift_time_offset (int no_samples)
| Shift generator time offset by a number of samples (for correlated fading generators)
virtual void | init ()=0
| Initialize the generator.
virtual void | generate (int no_samples, cvec &output)=0
| Generate no_samples values from the fading process.
cvec | generate (int no_samples)
| Generate no_samples values from the fading process.

## Protected Attributes

bool | init_flag
| signals if generator is initialized or not
double | los_power
| Relative power of LOS component compared to diffuse component (K factor)
double | los_diffuse
| Diffuse component: sqrt(1 / (1 + los_power))
double | los_direct
| Direct component: sqrt(los_power / (1 + los_power))

## Detailed Description

Fading generator class.

Author
  Tony Ottosson, Adam Piatyszek and Zbigniew Dlugaszewski

Abstract base class defining the interface of a single tap fading generator. Besides pure interface methods it implements a common set_LOS_power() method for setting up the Rice factor to be used in fading generators, which inherit from this class.

Definition at line 228 of file channel.h.

The documentation for this class was generated from the following files:

- itpp/comm/channel.h
- itpp/comm/channel.cpp

Generated on Thu Aug 20 2015 21:02:53 for IT++ by Doxygen 1.8.9.1